#! /sw/bin/gawk -f

## gff2zff 

## Program used to convert a gff to a zff

substr($1,1,1) != "#" {
  if (seq[ct_seq] != $1)
    ct_seq++;
  seq[ct_seq]=$1;
  if (gene[$1,ct_gene[$1]] != $9)
    ct_gene[$1]++;
  gene[$1,ct_gene[$1]]=$9;
  ct_exon[$9]++;
  exon_pos1[$9,ct_exon[$9]]=$4;
  exon_pos2[$9,ct_exon[$9]]=$5;
  strand[$9]=$7;
}

END{
  OFS="\t";
  # This loop is for each sequence
  for (ct0=1;ct0<=ct_seq;ct0++){
    seq_id=seq[ct0];
    print ">"seq_id;
    # This loop is for each gene in the sequence
    for (ct1=1;ct1 <= ct_gene[seq_id];ct1++){
      gene_id=gene[seq_id,ct1];
      # This loop is for each exon in the gene
      for (ct2=1;ct2 <= ct_exon[gene_id];ct2++){
	if (strand[gene_id] == "+"){
	  if (ct_exon[gene_id] == 1)
	    exon_type="Esngl";
	  else if (ct2 == 1)
	    exon_type="Einit";
	  else if (ct2 == ct_exon[gene_id])
	    exon_type="Eterm";
	  else 
	    exon_type="Exon";
	  print exon_type, exon_pos1[gene_id,ct2], exon_pos2[gene_id,ct2],gene_id;
	} else {
	  if (ct_exon[gene_id] == 1)
	    exon_type="Esngl";
	  else if (ct2 == 1)
	    exon_type="Eterm";
	  else if (ct2 == ct_exon[gene_id])
	    exon_type="Einit";
	  else 
	    exon_type="Exon";
	  print exon_type, exon_pos2[gene_id,ct2], exon_pos1[gene_id,ct2],gene_id;	  
	}
      }
    }
  }
}
