#! /sw/bin/gawk -f  

BEGIN{

  offset1=ARGV[1];
  offset2=ARGV[2];
  seq_strand=ARGV[3];
  seq_name=ARGV[4];
    
  ARGV[1]=ARGV[2]=ARGV[3]=ARGV[4]="";

  # gff data structure
  sequence = 1;
  feature  = 2;
  source   = 3;
  start    = 4;
  end      = 5;
  score    = 6;
  strand   = 7;
  frame    = 8;
  gene     = 9;

  gff_format="%s\t%s\t%s\t%d\t%d\t%f\t%s\t%d\t%s\n";
}
substr($1,1,1)!="#"{
     # ct counts the number of the exons
         ct++;
     # Storing all the exonic information 
     seq[ct]=$sequence;
     feat[ct]=$feature;
     sour[ct]=$source;
     p1[ct]=$start;
     p2[ct]=$end;
     scr[ct]=$score;
     str[ct]=$strand;
     fr[ct]=$frame;
     gen[ct]=$gene;
}
END{
      # Printing forward genes
      if (seq_strand == "+"){
        for (i=1;i<=ct;i++)
               printf "%s\t%s\t%s\t%d\t%d\t%.2f\t%s\t%d\t%s\n", 
             seq_name, feat[i], sour[i], p1[i] - offset1 + 1 ,
                           p2[i] - offset1 + 1, scr[i], str[i], fr[i], gen[i];  
      }
      else {
      # Printing reverse genes
                for (i=ct;i>0;i--)
                   printf "%s\t%s\t%s\t%d\t%d\t%.2f\t%s\t%d\t%s\n", 
             seq_name, feat[i], sour[i],  offset2 - p2[i]  + 1 ,
                           offset2 - p1[i] + offset + 1, scr[i], (str[i]=="+")?"-":"+", fr[i], gen[i];
      }
}
  
